import FSA.*;
import java.util.Stack;
import java.util.Hashtable;
import java.util.Enumeration;

public class Subset {

    //------------------------ YOUR CODE STARTS HERE -------------------------

    // Hint: Implement Dstates as a Hashtable from StateSet -> Boolean
    // (marked/unmarked). Create actual DFA states by using another
    // Hashtable from StateSet --> Integer (DFA state counter).  Note
    // that move(T, a) may be empty, in which case e-closure(move(T,a))
    // should not be added to Dstates.


    //------------------------ YOUR CODE ENDS HERE ---------------------------

    public static void main(String [] args) {
	
	if (args.length < 1) {
	    System.err.println("Usage: java Subset <NFA-spec>");
	    System.exit(1);
	}

	String nfa_name = args[0];

	try {
	    NFA_Reader r = new NFA_Reader(args[0]);
	    NFA N = r.read();
	    DFA D = subset_construction(N);
	    System.out.print(D);
	}
	catch (Exception e) {
	    System.err.println(e);
	    System.exit(1);
	}
    }

}
